<?php
ini_set('pcre.jit', '0');
    class Analyze {
        private $library_path = false;
        private $database_path = false;
        private $db_link = null;
        private $file_volume_array = array();
        private $version_uuid_list = false;
        private $setting_checksum = false;
        private $setting_exif = false;
        private $setting_created = false;
        private $setting_filename = false;
        private $setting_width = false;
        private $setting_height = false;
        private $setting_size = false;
        private $crc = "";
        private $result = "";
        private $library_version = 4;
        
        public function __construct($uuid_list, $library_path, $setting_checksum, $setting_exif, $setting_created, $setting_filename, $setting_width, $setting_height, $setting_size) {
            $this->library_path = trim($library_path);
            @unlink("/tmp/Library_tmp.apdb");
            if(is_readable($this->library_path."/database/Photos.sqlite")) {
                copy ($this->library_path."/database/Photos.sqlite", "/tmp/Library_tmp.apdb");
            } elseif(is_readable($this->library_path."/database/Library.apdb")) {
                copy ($this->library_path."/database/Library.apdb", "/tmp/Library_tmp.apdb");
            } elseif(is_readable($this->library_path."/database/photos.db")) {
                copy ($this->library_path."/database/photos.db", "/tmp/Library_tmp.apdb");
            } else {
                echo "database files not available or unreadable.";
                die();
            }            //$this->database_path = $this->library_path."/database/Library.apdb";
            $this->database_path = "/tmp/Library_tmp.apdb";
            $this->version_uuid_list = $uuid_list;
            
            if ($setting_checksum == "true") {
                $this->setting_checksum = true;
            }
            
            if ($setting_exif == "true") {
                $this->setting_exif = true;
            }
            
            if ($setting_created == "true") {
                $this->setting_created = true;
            }
            
            if ($setting_filename != "0") {
                $this->setting_filename = $setting_filename;
            }
            
            if ($setting_width == "true") {
                $this->setting_width = true;
            }
            
            if ($setting_height == "true") {
                $this->setting_height = true;
            }
            
            if ($setting_size == "true") {
                $this->setting_size = true;
            }
            
            $this->populate_file_volume_array();
            $this->process_uuid_list();
            $this->return_result();
            
            unlink ($this->database_path);
        }
        
        private function return_result() {
            if (!$this->crc) {
                $this->result .= "\nThe selected photos are NOT duplicates according to the selected detection algorithms.";
            } else {
                $this->result .= "\nThe selected photos are duplicates according to the selected detection algorithms.";
            }
            
            echo $this->result;
        }
        
        private function process_uuid_list() {
            $hasFileVolumeColumn = false;
            
            if ($this->connect_database()) {
                $handle = $this->db_link->prepare("PRAGMA table_info('RKMaster')");
                $handle->execute();
                
                $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                
                if ($result) {
                    foreach($result as $row){
                        $name = $row->name;
                        if ($name == "fileVolumeUuid") {
                            $hasFileVolumeColumn = true;
                        }
                        //echo $name."\n";
                    }
                }
                
                if ($this->version_uuid_list) {
                    $version_uuid_array = explode("%BREAKPOINT%", $this->version_uuid_list);
                    
                    foreach ($version_uuid_array as $version_uuid) {
                        $version_uuid = trim($version_uuid);
                        
                        if ($this->library_version == "6"){
                            // TODO trimma $version_uuid från applescriptets till databasens längd
                            $version_uuid = substr($version_uuid, 0, 36);
                            
                            if (strlen($version_uuid) == 36) {
                                
                                $handle = $this->db_link->prepare('select * from ZASSET where ZUUID = ? limit 1');
                                
                                $handle->bindValue(1, $version_uuid);
                                
                                $handle->execute();
                                
                                $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                                
                                if ($result) {
                                    foreach($result as $row){
                                        $z_pk = $row->Z_PK;
                                        $filename = $row->ZFILENAME;
                                        // print_r($row);
                                    }
                                }
                                $handle = $this->db_link->prepare('select ZPUBLICGLOBALUUID, ZORIGINALFILENAME, ZORIGINALFILESIZE, ZADJUSTEDFINGERPRINT, ZORIGINALWIDTH, ZORIGINALHEIGHT from ZADDITIONALASSETATTRIBUTES where ZASSET = ? limit 1');
                                
                                $handle->bindValue(1, $z_pk);
                                
                                $handle->execute();
                                
                                $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                                
                                if ($result) {
                                    foreach($result as $row){
                                        $masterFilesize = $row->ZORIGINALFILESIZE;
                                        $masterWidth = $row->ZORIGINALWIDTH;
                                        $masterHeight = $row->ZORIGINALHEIGHT;
                                        $adjustment_uuid = $row->ZADJUSTEDFINGERPRINT;
                                        $originalFilename = $row->ZORIGINALFILENAME;
                                        //     print_r($row);
                                    }
                                    
                                    $full_path = $this->library_path."/originals/".substr($version_uuid, 0, 1)."/".$filename;
                                    
                                    $this->process_file($version_uuid, $full_path, $adjustment_uuid);
                                }
                                
                                
                            }
                        }elseif ($this->library_version == "5"){
                            // TODO trimma $version_uuid från applescriptets till databasens längd
                            $version_uuid = substr($version_uuid, 0, 36);
                            
                            if (strlen($version_uuid) == 36) {
                                
                                $handle = $this->db_link->prepare('select * from ZGENERICASSET where ZUUID = ? limit 1');
                                
                                $handle->bindValue(1, $version_uuid);
                                
                                $handle->execute();
                                
                                $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                                
                                if ($result) {
                                    foreach($result as $row){
                                        $z_pk = $row->Z_PK;
                                        $filename = $row->ZFILENAME;
                                        // print_r($row);
                                    }
                                }
                                $handle = $this->db_link->prepare('select ZPUBLICGLOBALUUID, ZORIGINALFILENAME, ZORIGINALFILESIZE, ZADJUSTEDFINGERPRINT, ZORIGINALWIDTH, ZORIGINALHEIGHT from ZADDITIONALASSETATTRIBUTES where ZASSET = ? limit 1');
                                
                                $handle->bindValue(1, $z_pk);
                                
                                $handle->execute();
                                
                                $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                                
                                if ($result) {
                                    foreach($result as $row){
                                        $masterFilesize = $row->ZORIGINALFILESIZE;
                                        $masterWidth = $row->ZORIGINALWIDTH;
                                        $masterHeight = $row->ZORIGINALHEIGHT;
                                        $adjustment_uuid = $row->ZADJUSTEDFINGERPRINT;
                                        $originalFilename = $row->ZORIGINALFILENAME;
                                        //     print_r($row);
                                    }
                                    
                                    $full_path = $this->library_path."/originals/".substr($version_uuid, 0, 1)."/".$filename;
                                    
                                    $this->process_file($version_uuid, $full_path, $adjustment_uuid);
                                }
                                
                                
                            }
                        }else{
                            if (strlen($version_uuid) == 22) {
                                $handle = $this->db_link->prepare('select masterUuid, adjustmentUuid from RKVersion where uuid = ? limit 1');
                                
                                $handle->bindValue(1, $version_uuid);
                                
                                $handle->execute();
                                
                                $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                                
                                if ($result) {
                                    foreach($result as $row){
                                        
                                        $master_uuid = $row->masterUuid;
                                        $adjustment_uuid = $row->adjustmentUuid;
                                    }
                                }
                                
                                if ($hasFileVolumeColumn) {
                                    $handle = $this->db_link->prepare('select imagePath,fileVolumeUuid from RKMaster where uuid = ? limit 1');
                                } else {
                                    $handle = $this->db_link->prepare('select imagePath from RKMaster where uuid = ? limit 1');
                                }
                                
                                $handle->bindValue(1, $master_uuid);
                                
                                $handle->execute();
                                
                                $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                                
                                if ($result) {
                                    foreach($result as $row){
                                        
                                        $imagePath = $row->imagePath;
                                        
                                        if ($hasFileVolumeColumn) {
                                            $fileVolumeUuid = $row->fileVolumeUuid;
                                        } else {
                                            $fileVolumeUuid = null;
                                        }
                                        
                                        if ($fileVolumeUuid == null) {
                                            // TODO verifier att vi verkligen hamnar här!
                                            $full_path = $this->library_path."/Masters/".$imagePath;
                                        } else {
                                            $full_path = "/Volumes/".$this->file_volume_array[$fileVolumeUuid]."/".$imagePath;
                                        }
                                    }
                                }
                                
                                $this->process_file($version_uuid, $full_path, $adjustment_uuid);
                            }
                        }
                    }
                } else {
                    echo "ERROR! no uuid(s).\n";
                    die();
                }
            } else {
                echo "ERROR! failed to connect to database.\n";
                die();
            }
        }
        
        private function process_file($version_uuid, $full_path, $adjustment_uuid) {
            $tmp = pathinfo($full_path);
            $filename = $tmp["basename"];
            
            $result = "FILEPATH : ".$full_path."\n";
            $crc = "";
            
            if(is_readable($full_path)) {
                
                if($this->setting_checksum) {
                    $tmp = sha1_file($full_path).":".$adjustment_uuid;
                    $crc .= $tmp;
                    $result .= "CHECKSUM : ".$tmp."\n";
                }
                
                if($this->setting_exif) {
                    $tmp = @exif_read_data($full_path);
                    
                    if (isset($tmp["DateTimeOriginal"])) {
                        $created = $tmp["DateTimeOriginal"];
                        $crc .= $created;
                    } else {
                        $created = "NOT FOUND";
                    }
                    
                    $result .= "EXIF CREATION DATE : ".$created."\n";
                }
                
                if($this->setting_created) {
                    $tmp = @exif_read_data($full_path);
                    
                    if (isset($tmp["DateTime"])) {
                        $created = $tmp["DateTime"];
                        $crc .= $created;
                    } else {
                        $created = "NOT FOUND";
                    }
                    
                    $result .= "CREATION DATE : ".$created."\n";
                }
                
                if($this->setting_filename) {
                    $tmp = mb_substr($filename, 0, $this->setting_filename);
                    $crc .= $tmp;
                    $result .= "FILENAME : ".$tmp."\n";
                }
                
                if($this->setting_width) {
                    $tmp = @shell_exec("sips -g pixelWidth \"".preg_replace("/\\\'/", "'", escapeshellcmd($full_path))."\"");
                    if(preg_match("/pixelWidth: ([0-9]{1,})/", $tmp, $matches)){
                        $width = $matches[1];
                        $crc .= $width;
                    } else {
                        $width = "NOT AVAILABLE";
                    }
                    
                    $result .= "WIDTH : ".$width."\n";
                }
                
                if($this->setting_height) {
                    $tmp = @shell_exec("sips -g pixelHeight \"".preg_replace("/\\\'/", "'", escapeshellcmd($full_path))."\"");
                    if(preg_match("/pixelHeight: ([0-9]{1,})/", $tmp, $matches)){
                        $height = $matches[1];
                        $crc .= $height;
                    } else {
                        $height = "NOT AVAILABLE";
                    }
                    
                    $result .= "HEIGHT : ".$height."\n";
                }
                
                if($this->setting_size) {
                    $tmp = filesize($full_path);
                    $crc .= $tmp;
                    $result .= "FILESIZE : ".$tmp."\n";
                }
                
                $result .= "\n---------------------------\n\n";
                
                if ($this->crc == "") {
                    $this->crc = $crc;
                } elseif ($this->crc && $this->crc != $crc) {
                    $this->crc = false;
                }
                
                $this->result .= $result;
            } else {
                $result .= "ERROR : Could not access file.\n";
            }
            
        }
        
         private function populate_file_volume_array() {
           try {
               if ($this->connect_database()) {
                   $handle = $this->db_link->prepare('SELECT name FROM sqlite_master WHERE type=? AND name=?');
                   $handle->bindValue(1, 'table');
                   $handle->bindValue(2, 'RKVolume');
                   
                   $handle->execute();
                   
                   $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                   
                   if (!$result) {
                       return false;
                   }
                   
                   $handle = $this->db_link->prepare('SELECT uuid,name FROM RKVolume');
                   
                   $handle->execute();
                   
                   $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                   
                   if ($result) {
                       foreach($result as $row){
                           $this->file_volume_array[$row->uuid] = $row->name;
                       }
                   }
                   
                   $this->db_link = null;
                   
               } else {
                   $this->log("DB connection failed");
                   return false;
               }
               
           }
           catch(\PDOException $ex){
               $this->log($ex->getMessage());
               return false;
           }
       }
        
        private function connect_database() {
            try {
                $this->db_link = new \PDO("sqlite:".$this->database_path);
                
                $this->db_link->setAttribute(PDO::ATTR_ERRMODE,
                                             PDO::ERRMODE_EXCEPTION);
                
                $handle = $this->db_link->prepare('SELECT name FROM sqlite_master WHERE type=? AND name=?');
                $handle->bindValue(1, 'table');
                $handle->bindValue(2, 'ZGENERICASSET');
                
                $handle->execute();
                
                $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                
                if ($result) {
                    $this->library_version = "5";
                }
            }
            catch(\PDOException $ex) {
                $this->log($ex->getMessage());
                return false;
            }
           
        try {
                $this->db_link = new \PDO("sqlite:".$this->database_path);
                
                $this->db_link->setAttribute(PDO::ATTR_ERRMODE,
                                            PDO::ERRMODE_EXCEPTION);
                
                $handle = $this->db_link->prepare('SELECT name FROM sqlite_master WHERE type=? AND name=?');
                $handle->bindValue(1, 'table');
                $handle->bindValue(2, 'ZASSET');
                
                $handle->execute();
                
                $result = $handle->fetchAll(\PDO::FETCH_OBJ);
                
                if ($result) {
                    $this->library_version = "6";
                }
            }
            catch(\PDOException $ex) {
                $this->log($ex->getMessage());
                return false;
            }
            return true;
        }
        
        private  function log($string) {
            echo "LOG : ".$string."\n";
        }
    }
    
    new Analyze($argv[1], $argv[2], $argv[3], $argv[4], $argv[5], $argv[6], $argv[7], $argv[8], $argv[9]);
