#!/bin/bash
#(c)2003-2021 Brattoo Propaganda Software.

CWD="$2";

echo $1;
echo $2;
echo $3;

cd "$1";

if test -f "/usr/bin/php"; then
    PHP="/usr/bin/php";
    PHPVERSION="system"
fi

if test -f "/Applications/brattoo/php/bin/php"; then
    PHP="/Applications/brattoo/php/bin/php";
    PHPVERSION="brattoo"
fi

PREFS_MODE=$(egrep -o '^MODE:[a-zA-Z0-9]+' settings.txt | cut -d":" -f2)
PREFS_CORES=$(egrep -o '^CORES:[a-zA-Z0-9]+' settings.txt | cut -d":" -f2)
PREFS_FULL_SCAN=$(egrep -o '^FULL_SCAN:[a-zA-Z0-9]+' settings.txt | cut -d":" -f2)
PREFS_CLEAR_DESCRIPTION=$(egrep -o '^CLEAR_DESCRIPTION:[a-zA-Z0-9]+' settings.txt | cut -d":" -f2)
PREFS_CHECKSUM=$(egrep -o '^CHECKSUM:[a-zA-Z0-9]+' settings.txt | cut -d":" -f2)
PREFS_EXIF=$(egrep -o '^EXIF:[a-zA-Z0-9]+' settings.txt | cut -d":" -f2)
PREFS_CREATED=$(egrep -o '^CREATED:[a-zA-Z0-9]+' settings.txt | cut -d":" -f2)
PREFS_FILENAME=$(egrep -o '^FILENAME:[a-zA-Z0-9]+' settings.txt | cut -d":" -f2)
PREFS_WIDTH=$(egrep -o '^WIDTH:[a-zA-Z0-9]+' settings.txt | cut -d":" -f2)
PREFS_HEIGHT=$(egrep -o '^HEIGHT:[a-zA-Z0-9]+' settings.txt | cut -d":" -f2)
PREFS_SIZE=$(egrep -o '^SIZE:[a-zA-Z0-9]+' settings.txt | cut -d":" -f2)
PREFS_THUMB_MAX_SIZE=$(egrep -o '^THUMB_MAX_SIZE:[a-zA-Z0-9]+' settings.txt | cut -d":" -f2)
PREFS_THUMB_MAX_WIDTH_HEIGHT=$(egrep -o '^THUMB_MAX_WIDTH_HEIGHT:[a-zA-Z0-9]+' settings.txt | cut -d":" -f2)
PREFS_FACE_MAX_WIDTH_HEIGHT=$(egrep -o '^FACE_MAX_WIDTH_HEIGHT:[a-zA-Z0-9]+' settings.txt | cut -d":" -f2)
PREFS_KEEPHEIC=$(egrep -o '^KEEPHEIC:[a-zA-Z0-9]+' settings.txt | cut -d":" -f2)
PREFS_PERCEPTIVE_TOLERANCE=$(egrep -o '^PERCEPTIVE_TOLERANCE:[a-zA-Z0-9]+' settings.txt | cut -d":" -f2)

rm MISSING.txt 2> /dev/null;
touch MISSING.txt;
rm FACES.txt 2> /dev/null;
touch FACES.txt;
rm FILESIZE.txt 2> /dev/null;
rm THUMBNAILS.txt 2> /dev/null;
touch THUMBNAILS.txt
rm CRC_IMAGEID.txt 2> /dev/null;
rm CRC_NO_IMAGEID.txt 2> /dev/null;
rm DUPLICATE_CRCS.txt 2> /dev/null;
rm DUPLICATES_FINISHED.txt 2> /dev/null;
rm ORIGINALS.txt 2> /dev/null;
touch ORIGINALS.txt;
rm DUPLICATES.txt 2> /dev/null;
touch DUPLICATES.txt;
rm PROCESSED.txt 2> /dev/null;
rm WHEREINPROCESS.txt 2> /dev/null;
rm CORRUPT.txt 2> /dev/null;
touch CORRUPT.txt;

mkdir ~/Library/Caches/com.brattoo.duplicate-annihilator-photos 2> /dev/null

maxjobs=$PREFS_CORES;
echo $maxjobs;
runningjobs=0;

echo "step 0";
echo "0" > WHEREINPROCESS.txt

${PHP} "${CWD}/read_uuid_create_metadata.php" "$3" "$1" $PREFS_FULL_SCAN $PREFS_CLEAR_DESCRIPTION $PREFS_MODE $PREFS_KEEPHEIC

echo "step 1";
echo "1" > WHEREINPROCESS.txt
time while read -r line ; 
do  
    if [ $runningjobs -ge $maxjobs ]; then
        wait;
        runningjobs=0;
    fi

(${PHP} "${CWD}/worker.php" "${line}" "$1" ${PREFS_FACE_MAX_WIDTH_HEIGHT} ${PREFS_THUMB_MAX_WIDTH_HEIGHT} ${PREFS_MODE} ${PREFS_CHECKSUM} ${PREFS_EXIF} ${PREFS_CREATED} ${PREFS_FILENAME} ${PREFS_WIDTH} ${PREFS_HEIGHT} ${PREFS_SIZE} ${PREFS_PERCEPTIVE_TOLERANCE} ${PHPVERSION} ${PREFS_THUMB_MAX_SIZE})&
    ((runningjobs++))
done< joblist.txt;

echo "step 2";
echo "2" > WHEREINPROCESS.txt
stillrunning=$(ps|grep locateduplicates_v4.sh|wc -l)
while [  $stillrunning -gt 3 ]; do
    echo "sleep"
    stillrunning=$(ps|grep locateduplicates_v4.sh|wc -l)
    sleep 1
done

sleep 2

echo "step 3";
echo "3" > WHEREINPROCESS.txt
time sort CRC_NO_IMAGEID.txt|uniq -d  > DUPLICATE_CRCS.txt;

echo "step 4";
echo "4" > WHEREINPROCESS.txt

${PHP} "${CWD}/sorter.php" "$1"

echo "step 5";
echo "5" > WHEREINPROCESS.txt
sort -u -o ORIGINALS.txt ORIGINALS.txt 
sort -u -o DUPLICATES.txt DUPLICATES.txt 

echo "step 6"
echo "6" > WHEREINPROCESS.txt
